using System;
using System.Configuration;

namespace MockDataProvider.Configuration
{
    internal class ConfigurationHelper
    {
        #region Factory

        public static readonly ConfigurationHelper Instance = new ConfigurationHelper();

        #endregion

        #region Private Vars

        private readonly ConfigurationInformation _config;

        #endregion

        #region Constructors

        private ConfigurationHelper( )
        {
            try
            {
                _config = ConfigurationManager.GetSection( "MockDataProvider" ) as ConfigurationInformation;
            }
            catch
            {
                throw;
            }
        }

        #endregion

        #region Properties

        public string RealDataProvider
        {
            get
            {
                return _config.RealDataProvider;
            }
        }

        public string CacheFile
        {
            get
            {
                return _config.CacheFile;
            }
        }

        public bool MockMode
        {
            get
            {
                return _config.MockMode;
            }
        }

        #endregion
    }
}